import React from 'react';
import './Icon.scss';

const Icon = (props) => {
  const icons = {
    idea: [
      'M677.2 272.2c-47.2-45.4-109.2-68.8-174.8-66.4-125.8 5-228.4 111.4-228.8 237.4-0.2 55.8 19.4 110.2 55.2 153 51.6 62 80 140.2 80 220.4 0 0-5.4 36.8 20.8 36.8h164.8c26.8 0 20.8-36.8 20.8-36.8 0-78.4 28.8-156 83.4-224.4 33.8-42.6 51.8-93.8 51.8-148.2 0-65.4-26-126.6-73.2-171.8zM666 566.2c-59.4 74.4-91.2 159.2-92.4 245.6h-123.2c-1.2-88.2-32.8-174-89.6-242.2-29.4-35.4-45.6-80.2-45.4-126.2 0.4-104 85-191.8 188.8-196 54.2-2 105.4 17.4 144.2 54.8 39 37.4 60.4 87.8 60.4 141.8-0.2 45-14.8 87.2-42.8 122.2z',
      'M786.4 135.6c-8.2-8.2-21.4-8.2-29.4 0l-50.8 50.8c-8.2 8.2-8.2 21.4 0 29.4s21.4 8.2 29.4 0l50.8-50.8c8.2-8 8.2-21.2 0-29.4z',
      'M595.2 881.8h-166.4c-11.6 0-20.8 9.4-20.8 20.8 0 11.6 9.4 20.8 20.8 20.8h166.4c11.6 0 20.8-9.4 20.8-20.8s-9.4-20.8-20.8-20.8z',
      'M563.8 960.2h-103.4c-11.6 0-20.8 9.4-20.8 20.8 0 11.6 9.4 20.8 20.8 20.8h103.4c11.6 0 20.8-9.4 20.8-20.8s-9.4-20.8-20.8-20.8z',
      'M512 135.4c11.6 0 20.8-9.4 20.8-20.8v-71.8c0-11.6-9.4-20.8-20.8-20.8s-20.8 9.4-20.8 20.8v71.8c0 11.6 9.2 20.8 20.8 20.8z',
      'M317.8 216c8.2-8.2 8.2-21.4 0-29.4l-50.8-50.8c-8.2-8.2-21.4-8.2-29.4 0s-8.2 21.4 0 29.4l50.8 50.8c8.2 8 21.4 8 29.4 0z',
      'M879.2 389.2h-71.8c-11.6 0-20.8 9.4-20.8 20.8s9.4 20.8 20.8 20.8h71.8c11.6 0 20.8-9.4 20.8-20.8s-9.4-20.8-20.8-20.8z',
      'M216.6 389.2h-71.8c-11.6 0-20.8 9.4-20.8 20.8s9.4 20.8 20.8 20.8h71.8c11.6 0 20.8-9.4 20.8-20.8s-9.2-20.8-20.8-20.8z',
    ],
  };

  const sizes = {
    xs: 12,
    sm: 16,
    md: 22,
    lg: 30,
    xl: 36,
  };

  const keysIcons = Object.keys(icons);
  const keysSizes = Object.keys(sizes);
  let icon = icons.default;

  if (keysIcons.includes(props.icon)) {
    icon = icons[props.icon];
  }

  let size = sizes.sm;
  if (props.size) {
    if (keysSizes.includes(props.size)) {
      size = sizes[props.size];
    } else if (!Number.isNaN(props.size)) {
      ({ size } = props);
    }
  }

  return (
    <div // eslint-disable-line
      style={{
        color: props.color || '',
      }}
      className={`Icon ${props.className || ''}`}
      onClick={props.onClick}
    >
      <svg fill="currentColor" width={size} height={size} viewBox="0 0 1024 1024">
        {icon.map((path) => (
          <path key={path} d={path} />
        ))}
      </svg>
    </div>
  );
};

export default Icon;
